package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.shop.service.CommissionRoleService;
import com.gxwebsoft.shop.entity.CommissionRole;
import com.gxwebsoft.shop.param.CommissionRoleParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 分红角色控制器
 *
 * @author 科技小王子
 * @since 2024-12-02 12:43:40
 */
@Api(tags = "分红角色管理")
@RestController
@RequestMapping("/api/shop/commission-role")
public class CommissionRoleController extends BaseController {
    @Resource
    private CommissionRoleService commissionRoleService;

    @ApiOperation("分页查询分红角色")
    @GetMapping("/page")
    public ApiResult<PageResult<CommissionRole>> page(CommissionRoleParam param) {
        // 使用关联查询
        return success(commissionRoleService.pageRel(param));
    }

    @ApiOperation("查询全部分红角色")
    @GetMapping()
    public ApiResult<List<CommissionRole>> list(CommissionRoleParam param) {
        // 使用关联查询
        return success(commissionRoleService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:commissionRole:list')")
    @ApiOperation("根据id查询分红角色")
    @GetMapping("/{id}")
    public ApiResult<CommissionRole> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(commissionRoleService.getByIdRel(id));
    }

    @ApiOperation("添加分红角色")
    @PostMapping()
    public ApiResult<?> save(@RequestBody CommissionRole commissionRole) {

        if (commissionRoleService.save(commissionRole)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改分红角色")
    @PutMapping()
    public ApiResult<?> update(@RequestBody CommissionRole commissionRole) {
        if (commissionRoleService.updateById(commissionRole)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除分红角色")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (commissionRoleService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加分红角色")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<CommissionRole> list) {
        if (commissionRoleService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改分红角色")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<CommissionRole> batchParam) {
        if (batchParam.update(commissionRoleService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除分红角色")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (commissionRoleService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
